/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Diff of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.3 Revision 1.76
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.3 2004/11/27 11:26:52 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.76 2009/12/11 21:33:30 robbat2 Exp $
4# 4#
5# This eclass provides functions for querying the installed kernel 5# Original author: John Mylchreest <johnm@gentoo.org>
6# source version, selected kernel options etc. 6# Maintainer: kernel-misc@gentoo.org
7# 7#
8# Please direct your bugs to the current eclass maintainer :)
8 9
9ECLASS=linux-info 10# @ECLASS: linux-info.eclass
10INHERITED="$INHERITED $ECLASS" 11# @MAINTAINER:
12# kernel-misc@gentoo.org
13# @BLURB: eclass used for accessing kernel related information
14# @DESCRIPTION:
15# This eclass is used as a central eclass for accessing kernel
16# related information for source or binary already installed.
17# It is vital for linux-mod.eclass to function correctly, and is split
18# out so that any ebuild behaviour "templates" are abstracted out
19# using additional eclasses.
20#
21# "kernel config" in this file means:
22# The .config of the currently installed sources is used as the first
23# preference, with a fall-back to bundled config (/proc/config.gz) if available.
24
25# A Couple of env vars are available to effect usage of this eclass
26# These are as follows:
27
28# @ECLASS-VARIABLE: KERNEL_DIR
29# @DESCRIPTION:
30# A string containing the directory of the target kernel sources. The default value is
31# "/usr/src/linux"
32
33# @ECLASS-VARIABLE: CONFIG_CHECK
34# @DESCRIPTION:
35# A string containing a list of .config options to check for before
36# proceeding with the install.
37#
38# e.g.: CONFIG_CHECK="MTRR"
39#
40# You can also check that an option doesn't exist by
41# prepending it with an exclamation mark (!).
42#
43# e.g.: CONFIG_CHECK="!MTRR"
44#
45# To simply warn about a missing option, prepend a '~'.
46# It may be combined with '!'.
47#
48# In general, most checks should be non-fatal. The only time fatal checks should
49# be used is for building kernel modules or cases that a compile will fail
50# without the option.
51#
52# This is to allow usage of binary kernels, and minimal systems without kernel
53# sources.
54
55# @ECLASS-VARIABLE: ERROR_<CFG>
56# @DESCRIPTION:
57# A string containing the error message to display when the check against CONFIG_CHECK
58# fails. <CFG> should reference the appropriate option used in CONFIG_CHECK.
59#
60# e.g.: ERROR_MTRR="MTRR exists in the .config but shouldn't!!"
61
62# @ECLASS-VARIABLE: KBUILD_OUTPUT
63# @DESCRIPTION:
64# A string passed on commandline, or set from the kernel makefile. It contains the directory
65# which is to be used as the kernel object directory.
66
67# There are also a couple of variables which are set by this, and shouldn't be
68# set by hand. These are as follows:
69
70# @ECLASS-VARIABLE: KV_FULL
71# @DESCRIPTION:
72# A read-only variable. It's a string containing the full kernel version. ie: 2.6.9-gentoo-johnm-r1
73
74# @ECLASS-VARIABLE: KV_MAJOR
75# @DESCRIPTION:
76# A read-only variable. It's an integer containing the kernel major version. ie: 2
77
78# @ECLASS-VARIABLE: KV_MINOR
79# @DESCRIPTION:
80# A read-only variable. It's an integer containing the kernel minor version. ie: 6
81
82# @ECLASS-VARIABLE: KV_PATCH
83# @DESCRIPTION:
84# A read-only variable. It's an integer containing the kernel patch version. ie: 9
85
86# @ECLASS-VARIABLE: KV_EXTRA
87# @DESCRIPTION:
88# A read-only variable. It's a string containing the kernel EXTRAVERSION. ie: -gentoo
89
90# @ECLASS-VARIABLE: KV_LOCAL
91# @DESCRIPTION:
92# A read-only variable. It's a string containing the kernel LOCALVERSION concatenation. ie: -johnm
93
94# @ECLASS-VARIABLE: KV_DIR
95# @DESCRIPTION:
96# A read-only variable. It's a string containing the kernel source directory, will be null if
97# KERNEL_DIR is invalid.
98
99# @ECLASS-VARIABLE: KV_OUT_DIR
100# @DESCRIPTION:
101# A read-only variable. It's a string containing the kernel object directory, will be KV_DIR unless
102# KBUILD_OUTPUT is used. This should be used for referencing .config.
103
104# @ECLASS-VARIABLE: I_KNOW_WHAT_I_AM_DOING
105# @DESCRIPTION:
106# Temporary variable for the migration to making linux-info non-fatal.
107
108# And to ensure all the weirdness with crosscompile
109inherit toolchain-funcs versionator
110
111EXPORT_FUNCTIONS pkg_setup
112
113DEPEND=""
114RDEPEND=""
115
116[ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && \
117DEPEND="kernel_linux? ( virtual/linux-sources )"
11 118
12# Overwritable environment Var's 119# Overwritable environment Var's
13# --------------------------------------- 120# ---------------------------------------
14KERNEL_DIR="${KERNEL_DIR:-/usr/src/linux}" 121KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}"
15 122
16 123
124# Bug fixes
125# fix to bug #75034
126case ${ARCH} in
127 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
128 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
129esac
130
131# @FUNCTION: set_arch_to_kernel
132# @DESCRIPTION:
133# Set the env ARCH to match what the kernel expects.
134set_arch_to_kernel() { export ARCH=$(tc-arch-kernel); }
135# @FUNCTION: set_arch_to_portage
136# @DESCRIPTION:
137# Set the env ARCH to match what portage expects.
138set_arch_to_portage() { export ARCH=$(tc-arch); }
139
140# qeinfo "Message"
141# -------------------
142# qeinfo is a quiet einfo call when EBUILD_PHASE
143# should not have visible output.
144qout() {
145 local outputmsg type
146 type=${1}
147 shift
148 outputmsg="${@}"
149 case "${EBUILD_PHASE}" in
150 depend) unset outputmsg;;
151 clean) unset outputmsg;;
152 preinst) unset outputmsg;;
153 esac
154 [ -n "${outputmsg}" ] && ${type} "${outputmsg}"
155}
156
157qeinfo() { qout einfo "${@}" ; }
158qeerror() { qout eerror "${@}" ; }
17 159
18# File Functions 160# File Functions
19# --------------------------------------- 161# ---------------------------------------
20 162
21# getfilevar accepts 2 vars as follows: 163# @FUNCTION: getfilevar
22# getfilevar <VARIABLE> <CONFIGFILE> 164# @USAGE: variable configfile
23 165# @RETURN: the value of the variable
166# @DESCRIPTION:
167# It detects the value of the variable defined in the file configfile. This is
168# done by including the configfile, and printing the variable with Make.
169# It WILL break if your makefile has missing dependencies!
24getfilevar() { 170getfilevar() {
25local ERROR 171local ERROR basefname basedname myARCH="${ARCH}"
26 ERROR=0 172 ERROR=0
27 173
28 [ -z "${1}" ] && ERROR=1 174 [ -z "${1}" ] && ERROR=1
29 [ -z "${2}" ] && ERROR=1
30 [ ! -f "${2}" ] && ERROR=1 175 [ ! -f "${2}" ] && ERROR=1
31 176
32 if [ "${ERROR}" = 1 ] 177 if [ "${ERROR}" = 1 ]
33 then 178 then
179 echo -e "\n"
34 eerror "getfilevar requires 2 variables, with the second a valid file." 180 eerror "getfilevar requires 2 variables, with the second a valid file."
35 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 181 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
36 else 182 else
37 grep -e "^$1[= ]" $2 | sed 's: = :=:' | cut -d= -f2- 183 basefname="$(basename ${2})"
38 fi 184 basedname="$(dirname ${2})"
39} 185 unset ARCH
40 186
187 echo -e "e:\\n\\t@echo \$(${1})\\ninclude ${basefname}" | \
188 make -C "${basedname}" M="${S}" ${BUILD_FIXES} -s -f - 2>/dev/null
189
190 ARCH=${myARCH}
191 fi
192}
193
194# @FUNCTION: getfilevar_noexec
195# @USAGE: variable configfile
196# @RETURN: the value of the variable
197# @DESCRIPTION:
198# It detects the value of the variable defined in the file configfile.
199# This is done with sed matching an expression only. If the variable is defined,
200# you will run into problems. See getfilevar for those cases.
41getfilevar_isset() { 201getfilevar_noexec() {
202 local ERROR basefname basedname mycat myARCH="${ARCH}"
203 ERROR=0
204 mycat='cat'
205
206 [ -z "${1}" ] && ERROR=1
207 [ ! -f "${2}" ] && ERROR=1
208 [ "${2%.gz}" != "${2}" ] && mycat='zcat'
209
210 if [ "${ERROR}" = 1 ]
211 then
212 echo -e "\n"
213 eerror "getfilevar_noexec requires 2 variables, with the second a valid file."
214 eerror " getfilevar_noexec <VARIABLE> <CONFIGFILE>"
215 else
216 ${mycat} "${2}" | \
217 sed -n \
218 -e "/^[[:space:]]*${1}[[:space:]]*=[[:space:]]*\(.*\)\$/{
219 s,^[^=]*[[:space:]]*=[[:space:]]*,,g ;
220 s,[[:space:]]*\$,,g ;
221 p
222 }"
223 fi
224}
225
226# @PRIVATE-VARIABLE: _LINUX_CONFIG_EXISTS_DONE
227# @DESCRIPTION:
228# This is only set if one of the linux_config_*exists functions has been called.
229# We use it for a QA warning that the check for a config has not been performed,
230# as linux_chkconfig* in non-legacy mode WILL return an undefined value if no
231# config is available at all.
232_LINUX_CONFIG_EXISTS_DONE=
233
234linux_config_qa_check() {
235 local f="$1"
236 if [ -z "${_LINUX_CONFIG_EXISTS_DONE}" ]; then
237 ewarn "QA: You called $f before any linux_config_exists!"
238 ewarn "QA: The return value of $f will NOT gaurenteed later!"
239 fi
240}
241
242# @FUNCTION: linux_config_src_exists
243# @RETURN: true or false
244# @DESCRIPTION:
245# It returns true if .config exists in a build directory otherwise false
246linux_config_src_exists() {
247 export _LINUX_CONFIG_EXISTS_DONE=1
248 [ -s "${KV_OUT_DIR}/.config" ]
249}
250
251# @FUNCTION: linux_config_bin_exists
252# @RETURN: true or false
253# @DESCRIPTION:
254# It returns true if .config exists in /proc, otherwise false
255linux_config_bin_exists() {
256 export _LINUX_CONFIG_EXISTS_DONE=1
257 [ -n "${I_KNOW_WHAT_I_AM_DOING}" -a -s "/proc/config.gz" ]
258}
259
260# @FUNCTION: linux_config_exists
261# @RETURN: true or false
262# @DESCRIPTION:
263# It returns true if .config exists otherwise false
264#
265# This function MUST be checked before using any of the linux_chkconfig_*
266# functions.
267linux_config_exists() {
268 linux_config_src_exists || linux_config_bin_exists
269}
270
271# @FUNCTION: require_configured_kernel
272# @DESCRIPTION:
273# This function verifies that the current kernel is configured (it checks against the existence of .config)
274# otherwise it dies.
275require_configured_kernel() {
276 if ! linux_config_src_exists; then
277 qeerror "Could not find a usable .config in the kernel source directory."
278 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
279 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
280 qeerror "it points to the necessary object directory so that it might find .config."
281 die "Kernel not configured; no .config found in ${KV_OUT_DIR}"
282 fi
283}
284
285# @FUNCTION: linux_chkconfig_present
286# @USAGE: option
287# @RETURN: true or false
288# @DESCRIPTION:
289# It checks that CONFIG_<option>=y or CONFIG_<option>=m is present in the current kernel .config
290# If linux_config_exists returns false, the results of this are UNDEFINED. You
291# MUST call linux_config_exists first.
292linux_chkconfig_present() {
293 linux_config_qa_check linux_chkconfig_present
42local RESULT 294 local RESULT
43 RESULT="$(getfilevar ${1} ${2})" 295 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
296 local config
297 config="${KV_OUT_DIR}/.config"
298 [ ! -f "${config}" ] && config="/proc/config.gz"
299 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
44 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1 300 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1
45} 301}
46 302
47getfilevar_ismodule() { 303# @FUNCTION: linux_chkconfig_module
304# @USAGE: option
305# @RETURN: true or false
306# @DESCRIPTION:
307# It checks that CONFIG_<option>=m is present in the current kernel .config
308# If linux_config_exists returns false, the results of this are UNDEFINED. You
309# MUST call linux_config_exists first.
310linux_chkconfig_module() {
311 linux_config_qa_check linux_chkconfig_module
48local RESULT 312 local RESULT
49 RESULT="$(getfilevar ${1} ${2})" 313 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
314 local config
315 config="${KV_OUT_DIR}/.config"
316 [ ! -f "${config}" ] && config="/proc/config.gz"
317 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
50 [ "${RESULT}" = "m" ] && return 0 || return 1 318 [ "${RESULT}" = "m" ] && return 0 || return 1
51} 319}
52 320
53getfilevar_isbuiltin() { 321# @FUNCTION: linux_chkconfig_builtin
322# @USAGE: option
323# @RETURN: true or false
324# @DESCRIPTION:
325# It checks that CONFIG_<option>=y is present in the current kernel .config
326# If linux_config_exists returns false, the results of this are UNDEFINED. You
327# MUST call linux_config_exists first.
328linux_chkconfig_builtin() {
329 linux_config_qa_check linux_chkconfig_builtin
54local RESULT 330 local RESULT
55 RESULT="$(getfilevar ${1} ${2})" 331 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
332 local config
333 config="${KV_OUT_DIR}/.config"
334 [ ! -f "${config}" ] && config="/proc/config.gz"
335 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
56 [ "${RESULT}" = "y" ] && return 0 || return 1 336 [ "${RESULT}" = "y" ] && return 0 || return 1
337}
338
339# @FUNCTION: linux_chkconfig_string
340# @USAGE: option
341# @RETURN: CONFIG_<option>
342# @DESCRIPTION:
343# It prints the CONFIG_<option> value of the current kernel .config (it requires a configured kernel).
344# If linux_config_exists returns false, the results of this are UNDEFINED. You
345# MUST call linux_config_exists first.
346linux_chkconfig_string() {
347 linux_config_qa_check linux_chkconfig_string
348 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
349 local config
350 config="${KV_OUT_DIR}/.config"
351 [ ! -f "${config}" ] && config="/proc/config.gz"
352 getfilevar_noexec "CONFIG_${1}" "${config}"
57} 353}
58 354
59# Versioning Functions 355# Versioning Functions
60# --------------------------------------- 356# ---------------------------------------
61 357
62# kernel_is returns true when the version is the same as the passed version 358# @FUNCTION: kernel_is
359# @USAGE: [-lt -gt -le -ge -eq] major_number [minor_number patch_number]
360# @RETURN: true or false
361# @DESCRIPTION:
362# It returns true when the current kernel version satisfies the comparison against the passed version.
363# -eq is the default comparison.
63# 364#
365# @CODE
64# For Example where KV = 2.6.9 366# For Example where KV = 2.6.9
65# kernel_is 2 4 returns false 367# kernel_is 2 4 returns false
66# kernel_is 2 returns true 368# kernel_is 2 returns true
67# kernel_is 2 6 returns true 369# kernel_is 2 6 returns true
68# kernel_is 2 6 8 returns false 370# kernel_is 2 6 8 returns false
69# kernel_is 2 6 9 returns true 371# kernel_is 2 6 9 returns true
70# 372# @CODE
373
71# got the jist yet? 374# got the jist yet?
72 375
73kernel_is() { 376kernel_is() {
74 # if we haven't determined the version yet, we need too. 377 # if we haven't determined the version yet, we need to.
75 get_version; 378 linux-info_get_any_version
76
77 local RESULT
78 RESULT=1
79
80 if [ -n "${1}" ]
81 then
82 [ "${1}" = "${KV_MAJOR}" ] && RESULT=0
83 fi
84
85 if [ -n "${2}" ]
86 then
87 RESULT=1
88 [ "${2}" = "${KV_MINOR}" ] && RESULT=0
89 fi
90
91 if [ -n "${3}" ]
92 then
93 RESULT=1
94 [ "${3}" = "${KV_PATCH}" ] && RESULT=0
95 fi
96 return ${RESULT}
97}
98 379
380 local operator test value x=0 y=0 z=0
381
382 case ${1} in
383 -lt|lt) operator="-lt"; shift;;
384 -gt|gt) operator="-gt"; shift;;
385 -le|le) operator="-le"; shift;;
386 -ge|ge) operator="-ge"; shift;;
387 -eq|eq) operator="-eq"; shift;;
388 *) operator="-eq";;
389 esac
390
391 for x in ${@}; do
392 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
393 value="${value}${x}"
394 z=$((${z} + 1))
395
396 case ${z} in
397 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
398 test="${test}${KV_MAJOR}";;
399 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
400 test="${test}${KV_MINOR}";;
401 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
402 test="${test}${KV_PATCH}";;
403 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
404 esac
405 done
406
407 [ ${test} ${operator} ${value} ] && return 0 || return 1
408}
409
410get_localversion() {
411 local lv_list i x
412
413 # ignore files with ~ in it.
414 for i in $(ls ${1}/localversion* 2>/dev/null); do
415 [[ -n ${i//*~*} ]] && lv_list="${lv_list} ${i}"
416 done
417
418 for i in ${lv_list}; do
419 x="${x}$(<${i})"
420 done
421 x=${x/ /}
422 echo ${x}
423}
424
425# internal variable, so we know to only print the warning once
426get_version_warning_done=
427
428# @FUNCTION: get_version
429# @DESCRIPTION:
430# It gets the version of the kernel inside KERNEL_DIR and populates the KV_FULL variable
431# (if KV_FULL is already set it does nothing).
432#
433# The kernel version variables (KV_MAJOR, KV_MINOR, KV_PATCH, KV_EXTRA and KV_LOCAL) are also set.
434#
435# The KV_DIR is set using the KERNEL_DIR env var, the KV_DIR_OUT is set using a valid
436# KBUILD_OUTPUT (in a decreasing priority list, we look for the env var, makefile var or the
437# symlink /lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build).
99get_version() { 438get_version() {
439 local kbuild_output
440
100 # no need to execute this twice assuming KV_FULL is populated. 441 # no need to execute this twice assuming KV_FULL is populated.
101 # we can force by unsetting KV_FULL 442 # we can force by unsetting KV_FULL
102 if [ -n "${KV_FULL}" ] 443 [ -n "${KV_FULL}" ] && return 0
103 then
104 # Lets keep this quiet eh?
105 # einfo "\${KV_FULL} is already set. Not running get_version again"
106 return
107 fi
108 444
109 # if we dont know KV_FULL, then we need too. 445 # if we dont know KV_FULL, then we need too.
110 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR 446 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR
111 unset KV_DIR 447 unset KV_DIR
112 448
113 # KV_DIR will contain the full path to the sources directory we should use 449 # KV_DIR will contain the full path to the sources directory we should use
450 [ -z "${get_version_warning_done}" ] && \
114 einfo "Determining the location of the kernel source code" 451 qeinfo "Determining the location of the kernel source code"
115 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})" 452 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})"
116 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}" 453 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}"
117 454
118 if [ -z "${KV_DIR}" ] 455 if [ -z "${KV_DIR}" ]
119 then 456 then
457 if [ -z "${get_version_warning_done}" ]; then
458 get_version_warning_done=1
120 eerror "Unable to find kernel sources at ${KERNEL_DIR}" 459 qeerror "Unable to find kernel sources at ${KERNEL_DIR}"
121 die 460 #qeinfo "This package requires Linux sources."
461 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then
462 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, "
463 qeinfo "(or the kernel you wish to build against)."
464 qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location"
465 else
466 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against."
467 fi
122 fi 468 fi
123 469 return 1
470 fi
471
472 if [ -z "${get_version_warning_done}" ]; then
473 qeinfo "Found kernel source directory:"
474 qeinfo " ${KV_DIR}"
475 fi
476
477 if [ ! -s "${KV_DIR}/Makefile" ]
478 then
479 if [ -z "${get_version_warning_done}" ]; then
480 get_version_warning_done=1
481 qeerror "Could not find a Makefile in the kernel source directory."
482 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources"
483 fi
484 return 1
485 fi
486
487 # OK so now we know our sources directory, but they might be using
488 # KBUILD_OUTPUT, and we need this for .config and localversions-*
489 # so we better find it eh?
490 # do we pass KBUILD_OUTPUT on the CLI?
491 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
492
493 # And if we didn't pass it, we can take a nosey in the Makefile
494 kbuild_output="$(getfilevar_noexec KBUILD_OUTPUT ${KV_DIR}/Makefile)"
495 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
496
124 # And contrary to existing functions I feel we shouldn't trust the 497 # And contrary to existing functions I feel we shouldn't trust the
125 # directory name to find version information as this seems insane. 498 # directory name to find version information as this seems insane.
126 # so we parse ${KV_DIR}/Makefile 499 # so we parse ${KV_DIR}/Makefile
127 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)" 500 KV_MAJOR="$(getfilevar_noexec VERSION ${KV_DIR}/Makefile)"
128 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)" 501 KV_MINOR="$(getfilevar_noexec PATCHLEVEL ${KV_DIR}/Makefile)"
129 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)" 502 KV_PATCH="$(getfilevar_noexec SUBLEVEL ${KV_DIR}/Makefile)"
130 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)" 503 KV_EXTRA="$(getfilevar_noexec EXTRAVERSION ${KV_DIR}/Makefile)"
504
505 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
506 then
507 if [ -z "${get_version_warning_done}" ]; then
508 get_version_warning_done=1
509 qeerror "Could not detect kernel version."
510 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
511 fi
512 return 1
513 fi
514
131 # and in newer versions we can also pull LOCALVERSION if it is set. 515 # and in newer versions we can also pull LOCALVERSION if it is set.
132 KV_LOCAL="$(cat ${KV_DIR}/localversion* 2>/dev/null)$(getfilevar CONFIG_LOCALVERSION ${KV_DIR}/.config | sed 's:"::g')" 516 # but before we do this, we need to find if we use a different object directory.
133 517 # This *WILL* break if the user is using localversions, but we assume it was
518 # caught before this if they are.
519 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}" == "$(uname -r)" ] && \
520 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build}"
521
522 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})"
523 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}"
524 if [ -n "${KV_OUT_DIR}" ];
525 then
526 qeinfo "Found kernel object directory:"
527 qeinfo " ${KV_OUT_DIR}"
528
529 KV_LOCAL="$(get_localversion ${KV_OUT_DIR})"
530 fi
531 # and if we STILL have not got it, then we better just set it to KV_DIR
532 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}"
533
534 KV_LOCAL="${KV_LOCAL}$(get_localversion ${KV_DIR})"
535 if linux_config_src_exists; then
536 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)"
537 KV_LOCAL="${KV_LOCAL//\"/}"
538
539 # For things like git that can append extra stuff:
540 [ -e ${KV_DIR}/scripts/setlocalversion ] &&
541 linux_chkconfig_builtin LOCALVERSION_AUTO &&
542 KV_LOCAL="${KV_LOCAL}$(sh ${KV_DIR}/scripts/setlocalversion ${KV_DIR})"
543 fi
544
134 # And we should set KV_FULL to the full expanded version 545 # And we should set KV_FULL to the full expanded version
135 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}" 546 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}"
136 547
137 if [ -z "${KV_FULL}" ] 548 qeinfo "Found sources for kernel version:"
138 then 549 qeinfo " ${KV_FULL}"
139 eerror "We are unable to find a usable kernel source tree in ${KV_DIR}" 550
140 eerror "Please check a kernel source exists in this directory." 551 return 0
141 die 552}
553
554# @FUNCTION: get_running_version
555# @DESCRIPTION:
556# It gets the version of the current running kernel and the result is the same as get_version() if the
557# function can find the sources.
558get_running_version() {
559 KV_FULL=$(uname -r)
560
561 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then
562 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source)
563 unset KV_FULL
564 get_version
565 return $?
566 elif [[ -f ${ROOT}/lib/modules/${KV_FULL}/build/Makefile ]]; then
567 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/build)
568 unset KV_FULL
569 get_version
570 return $?
142 else 571 else
143 einfo "Found kernel source directory:" 572 KV_MAJOR=$(get_version_component_range 1 ${KV_FULL})
144 einfo " ${KV_DIR}" 573 KV_MINOR=$(get_version_component_range 2 ${KV_FULL})
145 einfo "with sources for kernel version:" 574 KV_PATCH=$(get_version_component_range 3- ${KV_FULL})
146 einfo " ${KV_FULL}" 575 KV_PATCH=${KV_PATCH//-*}
576 [[ -n ${KV_FULL#*-} ]] && [[ -n ${KV_FULL//${KV_FULL#*-}} ]] \
577 && KV_EXTRA="-${KV_FULL#*-}"
147 fi 578 fi
579 return 0
148} 580}
149 581
582# This next function is named with the eclass prefix to avoid conflicts with
583# some old versionator-like eclass functions.
150 584
585# @FUNCTION: linux-info_get_any_version
586# @DESCRIPTION:
587# This attempts to find the version of the sources, and otherwise falls back to
588# the version of the running kernel.
589linux-info_get_any_version() {
590 get_version
591 if [[ $? -ne 0 ]]; then
592 ewarn "Unable to calculate Linux Kernel version for build, attempting to use running version"
593 get_running_version
594 fi
595}
151 596
152 597
153# ebuild check functions 598# ebuild check functions
154# --------------------------------------- 599# ---------------------------------------
155 600
601# @FUNCTION: check_kernel_built
602# @DESCRIPTION:
603# This function verifies that the current kernel sources have been already prepared otherwise it dies.
156check_kernel_built() { 604check_kernel_built() {
157 # if we haven't determined the version yet, we need too. 605 # if we haven't determined the version yet, we need to
606 require_configured_kernel
158 get_version; 607 get_version
159 608
160 if [ ! -f "${KV_DIR}/System.map" ] 609 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ]
161 then 610 then
162 eerror "These sources have not yet been compiled." 611 eerror "These sources have not yet been prepared."
163 eerror "We cannot build against an uncompiled tree." 612 eerror "We cannot build against an unprepared tree."
164 eerror "To resolve this, please type the following:" 613 eerror "To resolve this, please type the following:"
165 eerror 614 eerror
166 eerror "# cd ${KV_DIR}" 615 eerror "# cd ${KV_DIR}"
167 eerror "# make oldconfig" 616 eerror "# make oldconfig"
168 eerror "# make bzImage modules modules_install" 617 eerror "# make modules_prepare"
169 eerror 618 eerror
170 eerror "Then please try merging this module again." 619 eerror "Then please try merging this module again."
171 die "Kernel sources need compiling first" 620 die "Kernel sources need compiling first"
172 fi 621 fi
173} 622}
174 623
624# @FUNCTION: check_modules_supported
625# @DESCRIPTION:
626# This function verifies that the current kernel support modules (it checks CONFIG_MODULES=y) otherwise it dies.
175check_modules_supported() { 627check_modules_supported() {
176 # if we haven't determined the version yet, we need too. 628 # if we haven't determined the version yet, we need too.
629 require_configured_kernel
177 get_version; 630 get_version
178 631
179 getfilevar_isset CONFIG_MODULES ${KV_DIR}/.config 632 if ! linux_chkconfig_builtin "MODULES"
180 if [ "$?" != 0 ]
181 then 633 then
182 eerror "These sources do not support loading external modules." 634 eerror "These sources do not support loading external modules."
183 eerror "to be able to use this module please enable \"Loadable modules support\"" 635 eerror "to be able to use this module please enable \"Loadable modules support\""
184 eerror "in your kernel, recompile and then try merging this module again." 636 eerror "in your kernel, recompile and then try merging this module again."
185 die No support for external modules in ${KV_FUll} config 637 die "No support for external modules in ${KV_FULL} config"
186 fi 638 fi
187} 639}
188 640
641# @FUNCTION: check_extra_config
642# @DESCRIPTION:
643# It checks the kernel config options specified by CONFIG_CHECK. It dies only when a required config option (i.e.
644# the prefix ~ is not used) doesn't satisfy the directive.
189check_extra_config() { 645check_extra_config() {
190local config negate error 646 local config negate die error reworkmodulenames
647 local soft_errors_count=0 hard_errors_count=0 config_required=0
648 # store the value of the QA check, because otherwise we won't catch usages
649 # after if check_extra_config is called AND other direct calls are done
650 # later.
651 local old_LINUX_CONFIG_EXISTS_DONE="${_LINUX_CONFIG_EXISTS_DONE}"
191 652
192 # if we haven't determined the version yet, we need too. 653 # if we haven't determined the version yet, we need to
193 get_version; 654 linux-info_get_any_version
194 655
195 einfo "Checking for suitable kernel configuration options" 656 # Determine if we really need a .config. The only time when we don't need
657 # one is when all of the CONFIG_CHECK options are prefixed with "~".
196 for config in ${CONFIG_CHECK} 658 for config in ${CONFIG_CHECK}
197 do 659 do
198 negate="${config:0:1}" 660 if [[ "${config:0:1}" != "~" ]]; then
199 if [ "${negate}" == "!" ]; 661 config_required=1
200 then 662 break
663 fi
664 done
665
666 # TODO: After we enable the new code for /proc/config.gz, we need to
667 # change this back to linux_config_exists.
668 if [[ ${config_required} == 0 ]]; then
669 # In the case where we don't require a .config, we can now bail out
670 # if the user has no .config as there is nothing to do. Otherwise
671 # code later will cause a failure due to missing .config.
672 if ! linux_config_src_exists; then
673 ewarn "Unable to check for the following kernel config options due"
674 ewarn "to absence of any configured kernel sources or compiled"
675 ewarn "config:"
676 for config in ${CONFIG_CHECK}; do
677 ewarn " - ${config#\~}"
678 done
679 ewarn "You're on your own to make sure they are set if needed."
680 export LINUX_CONFIG_EXISTS_DONE="${old_LINUX_CONFIG_EXISTS_DONE}"
681 return 0
682 fi
683 else
684 [ -n "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
685 fi
686
687 einfo "Checking for suitable kernel configuration options..."
688
689 for config in ${CONFIG_CHECK}
690 do
691 # if we specify any fatal, ensure we honor them
692 die=1
693 error=0
694 negate=0
695 reworkmodulenames=0
696
697 if [[ ${config:0:1} == "~" ]]; then
698 die=0
201 config="${config:1}" 699 config=${config:1}
202 if getfilevar_isset ${config} ${KV_DIR}/.config ; 700 elif [[ ${config:0:1} == "@" ]]; then
203 then 701 die=0
204 eerror " ${config}:\tshould not be set in the kernel configuration, but it is." 702 reworkmodulenames=1
703 config=${config:1}
704 fi
705 if [[ ${config:0:1} == "!" ]]; then
706 negate=1
707 config=${config:1}
708 fi
709
710 if [[ ${negate} == 1 ]]; then
711 linux_chkconfig_present ${config} && error=2
712 elif [[ ${reworkmodulenames} == 1 ]]; then
713 local temp_config="${config//*:}" i n
714 config="${config//:*}"
715 if linux_chkconfig_present ${config}; then
716 for i in ${MODULE_NAMES}; do
717 n="${i//${temp_config}}"
718 [[ -z ${n//\(*} ]] && \
719 MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}"
720 done
205 error=1 721 error=2
206 fi 722 fi
207 else 723 else
208 if ! getfilevar_isset ${config} ${KV_DIR}/.config ; 724 linux_chkconfig_present ${config} || error=1
209 then 725 fi
210 eerror " ${config}:\tshould be set in the kernel configuration, but isn't" 726
211 error=1 727 if [[ ${error} > 0 ]]; then
728 local report_func="eerror" local_error
729 local_error="ERROR_${config}"
730 local_error="${!local_error}"
731
732 if [[ -z "${local_error}" ]]; then
733 # using old, deprecated format.
734 local_error="${config}_ERROR"
735 local_error="${!local_error}"
212 fi 736 fi
737 if [[ ${die} == 0 && -z "${local_error}" ]]; then
738 #soft errors can be warnings
739 local_error="WARNING_${config}"
740 local_error="${!local_error}"
741 if [[ -n "${local_error}" ]] ; then
742 report_func="ewarn"
743 fi
744 fi
745
746 if [[ -z "${local_error}" ]]; then
747 [[ ${error} == 1 ]] \
748 && local_error="is not set when it should be." \
749 || local_error="should not be set. But it is."
750 local_error="CONFIG_${config}:\t ${local_error}"
751 fi
752 if [[ ${die} == 0 ]]; then
753 ${report_func} " ${local_error}"
754 soft_errors_count=$[soft_errors_count + 1]
755 else
756 ${report_func} " ${local_error}"
757 hard_errors_count=$[hard_errors_count + 1]
758 fi
213 fi 759 fi
214 done 760 done
215 761
216 if [ -n "${error}" ] ; 762 if [[ ${hard_errors_count} > 0 ]]; then
217 then
218 eerror "Please check to make sure these options are set correctly." 763 eerror "Please check to make sure these options are set correctly."
764 eerror "Failure to do so may cause unexpected problems."
219 eerror "Once you have satisfied these options, please try merging" 765 eerror "Once you have satisfied these options, please try merging"
220 eerror "this package again." 766 eerror "this package again."
767 export LINUX_CONFIG_EXISTS_DONE="${old_LINUX_CONFIG_EXISTS_DONE}"
221 die Incorrect kernel configuration options 768 die "Incorrect kernel configuration options"
769 elif [[ ${soft_errors_count} > 0 ]]; then
770 ewarn "Please check to make sure these options are set correctly."
771 ewarn "Failure to do so may cause unexpected problems."
772 else
773 eend 0
222 fi 774 fi
775 export LINUX_CONFIG_EXISTS_DONE="${old_LINUX_CONFIG_EXISTS_DONE}"
223} 776}
224 777
225check_zlibinflate() { 778check_zlibinflate() {
226 # if we haven't determined the version yet, we need too. 779 # if we haven't determined the version yet, we need to
780 require_configured_kernel
227 get_version; 781 get_version
228 782
229 # although I restructured this code - I really really really dont support it! 783 # although I restructured this code - I really really really dont support it!
230 784
231 # bug #27882 - zlib routines are only linked into the kernel 785 # bug #27882 - zlib routines are only linked into the kernel
232 # if something compiled into the kernel calls them 786 # if something compiled into the kernel calls them
233 # 787 #
234 # plus, for the cloop module, it appears that there's no way 788 # plus, for the cloop module, it appears that there's no way
235 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS 789 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS
236 # is on 790 # is on
237 791
238local INFLATE 792 local INFLATE
239local DEFLATE 793 local DEFLATE
240 794
241 einfo "Determining the usability of ZLIB_INFLATE support in your kernel" 795 einfo "Determining the usability of ZLIB_INFLATE support in your kernel"
242 796
243 ebegin "checking ZLIB_INFLATE" 797 ebegin "checking ZLIB_INFLATE"
244 getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config 798 linux_chkconfig_builtin CONFIG_ZLIB_INFLATE
245 eend $? 799 eend $?
246 [ "$?" != 0 ] && die 800 [ "$?" != 0 ] && die
247 801
248 ebegin "checking ZLIB_DEFLATE" 802 ebegin "checking ZLIB_DEFLATE"
249 getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config 803 linux_chkconfig_builtin CONFIG_ZLIB_DEFLATE
250 eend $? 804 eend $?
251 [ "$?" != 0 ] && die 805 [ "$?" != 0 ] && die
252 806
253
254 local LINENO_START 807 local LINENO_START
255 local LINENO_END 808 local LINENO_END
256 local SYMBOLS 809 local SYMBOLS
257 local x 810 local x
258 811
259 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)" 812 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)"
260 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)" 813 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)"
261 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START )) 814 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START ))
262 (( LINENO_END = $LINENO_END - 1 )) 815 (( LINENO_END = $LINENO_END - 1 ))
263 SYMBOLS="$(head -n $LINENO_END ${KERNEL_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')" 816 SYMBOLS="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')"
264 817
265 # okay, now we have a list of symbols 818 # okay, now we have a list of symbols
266 # we need to check each one in turn, to see whether it is set or not 819 # we need to check each one in turn, to see whether it is set or not
267 for x in $SYMBOLS ; do 820 for x in $SYMBOLS ; do
268 if [ "${!x}" = "y" ]; then 821 if [ "${!x}" = "y" ]; then
269 # we have a winner! 822 # we have a winner!
270 einfo "${x} ensures zlib is linked into your kernel - excellent" 823 einfo "${x} ensures zlib is linked into your kernel - excellent"
271 return 0 824 return 0
272 fi 825 fi
273 done 826 done
274 827
275 eerror 828 eerror
276 eerror "This kernel module requires ZLIB library support." 829 eerror "This kernel module requires ZLIB library support."
277 eerror "You have enabled zlib support in your kernel, but haven't enabled" 830 eerror "You have enabled zlib support in your kernel, but haven't enabled"
278 eerror "enabled any option that will ensure that zlib is linked into your" 831 eerror "enabled any option that will ensure that zlib is linked into your"
279 eerror "kernel." 832 eerror "kernel."
289 eerror "Please remember to recompile and install your kernel, and reboot" 842 eerror "Please remember to recompile and install your kernel, and reboot"
290 eerror "into your new kernel before attempting to load this kernel module." 843 eerror "into your new kernel before attempting to load this kernel module."
291 844
292 die "Kernel doesn't include zlib support" 845 die "Kernel doesn't include zlib support"
293} 846}
847
848################################
849# Default pkg_setup
850# Also used when inheriting linux-mod to force a get_version call
851# @FUNCTION: linux-info_pkg_setup
852# @DESCRIPTION:
853# Force a get_version() call when inherited from linux-mod.eclass and then check if the kernel is configured
854# to support the options specified in CONFIG_CHECK (if not null)
855linux-info_pkg_setup() {
856 linux-info_get_any_version
857
858 if kernel_is 2 4; then
859 if [ "$( gcc-major-version )" -eq "4" ] ; then
860 echo
861 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with"
862 ewarn "linux-2.4 (or modules building against a linux-2.4 kernel)!"
863 echo
864 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
865 ewarn "newer kernel that supports gcc-4."
866 echo
867 ewarn "Also be aware that bugreports about gcc-4 not working"
868 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
869 echo
870 epause 10
871 fi
872 fi
873
874 [ -n "${CONFIG_CHECK}" ] && check_extra_config;
875}

Legend:
Removed from v.1.3  
changed lines
  Added in v.1.76

  ViewVC Help
Powered by ViewVC 1.1.20